#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "boolean.h"
#include <unistd.h>
#include <assert.h>
#include <string.h>


/* Boolean function are loaded sequentially displaying properties...
*/

int   optalpha = 0, optlin = 0,  optdeg=0, optbal=0,  optnum=0, optzero = 0;
int degmin, degmax;
int linmin=0, linmax=0;
int zmin, zmax = 0;
float alphamin, alphamax;


boole myanfloadboole(FILE *src, int mode )
//-get the current boolean function
{
  boole res;
  char line[1024];
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
	{
	case '#':
	  break;
	case 'a' :
	case 'h' :
	  res = strtoboole ( line );
          return res;
	  break;
	default:;
	}
    }
    return NULL;
}



int balance( boole f )
{
int res = 0;
int * fct;
galois x;
fct = booleChi(  f  );
Fourier( fct, ffsize);
for( x = 0; x < ffsize; x++)
	if ( 0 == fct[x] ) 
			res = 1;
free( fct );
return res;
}


int zero( boole f )
{
int res = 0;
int * fct;
galois x;
fct = booleChi(  f  );
Fourier( fct, ffsize);
for( x = 0; x < ffsize; x++)
	if ( 0 == fct[x] ) 
			res++;
free( fct );
return res;
}

int tfr( boole f )
{
int res = 0;
int * fct;
galois x;
fct = booleChi(  f  );
Fourier( fct, ffsize);
for( x = 0; x < ffsize; x++)
	if ( abs( fct[x])  > res )
			res = abs( fct[x] );

free( fct );
return res;
}


int accept( boole f , int optnum, int num )
{
int ok = 1;
int tmp;
float t;

if ( optnum )
	return optnum == num;

if ( optlin  ){
	tmp  = tfr ( f );
        ok = ( linmin <= tmp ) && ( tmp <= linmax );
	
}

if ( ok && optbal  ) {
   ok = balance( f );
}

if ( ok && optalpha ){
	t = norme( f );
	ok = ( alphamin <= t ) && ( t <= alphamax );
}

if ( ok && optdeg  ){
	tmp  = degree( f );
	ok = ( degmin <= tmp ) && ( tmp <= degmax );
}
if ( ok && optzero ){
	tmp  = zero( f );
	ok = ( zmin <= tmp ) && ( tmp <= zmax );
}
return ok;
}



void pfboole( FILE *dst, char * format, boole f )
{
while ( *format ) {
        if ( *format == '%' ) {
                format++;
                switch( *format ) {
                 case 'x' : panf( dst, f ); break;
                 case 'd' : fprintf(dst, "deg=%d", degree(f)  ); break;
                 case 'a' : fprintf(dst, "alpha=%.6f", alpha( f ) ); break;
                 case 'w' : pwalsh(  f ) ; break;
                 case 's' : spectrum(  f ) ; break;
                 case 'n' : fprintf(dst, "\n"); break;
                 default  : fprintf(dst, "???"); break;
                }
          } else fprintf(dst, "%c", *format);
         format++;
}
}

int main( int argc, char*argv[] )

{
  FILE *src;
  boole f;
  int num = 0;
  int opt;
  int dim=6;
  char *fn = NULL , *format="%x%n";
  printf("\n#command line : ");
  for( opt = 0; opt < argc; opt++ )
	  printf(" %s", argv[opt] );
 int optM = 0;
 int total = 0;
  while ((opt = getopt(argc, argv, "a:bl:d:p:m:f:z:")) != -1) {
               switch (opt) {
               case 'a':
                   optalpha = 1; 
		   if ( 1 == sscanf(optarg,"%f:%f", &alphamin, &alphamax ) )
			   alphamax = alphamin;
                   break;
               case 'b':
                   optbal=1;
                   break;
               case 'm':
                   dim = atoi( optarg );
                   break;
               case 'f':
                   fn = strdup( optarg );
                   break;
               case 'p':
                   format   = strdup( optarg );
                   break;
	        case 'l':
                   optlin   = atoi( optarg );
		   if ( 1 == sscanf(optarg,"%d:%d", &linmin, &linmax) )
			   linmax = linmin;
                   break;
               case 'd':
                   optdeg = 1;
		   if ( 1 == sscanf(optarg,"%d:%d", &degmin, &degmax) )
			   degmax = degmin;
                   break;
               case 'z':
		   if ( 1 == sscanf(optarg,"%d:%d", &zmin, &zmax) )
			   zmax = zmin;
		   optzero = 1;
                   break;
               default: /* '?' */
                   fprintf(stderr, "%s : check usage!\n", argv[0]);
		   printf("option : -p format -a min:max -b balance  -m dimen  -dmin:max -lmin:max -zmin:max -f file...\n");
		   printf("./anfload.exe -m6 -f class-2-6.txt\n");
                   exit(EXIT_FAILURE);
               }
           }
  if ( ! fn ){
	src = stdin;
  } 
  src = fopen( fn , "r");
  if ( ! src ) {
	perror( fn );
	exit(1);
  }
  initboole( dim );
  printf("\n---\nselected %d-bit functions :\n", ffdimen );
  while ( (f = myanfloadboole( src , optM ) ) ){
	if ( accept( f, optnum, num  ) ) { 
                pfboole(stdout, format, f );
		total++;
	}
	num++;
  }
  fclose( src );
  printf("\n# %d Boolean functions among %d classes\n", total, num);
return 0;
}
