#ifndef BOOLEAN_H
#define BOOLEAN_H

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>


extern int ffsize;
extern int ffdimen;

typedef  uint32_t  galois;

void initboole( int m );

typedef unsigned char uchar;

typedef uchar* boole;
//-boolean type : table of 0, 1

int boolecmp( boole f, boole g );

boole getboole( );
//-allocation

boole  getboolecpy( boole f );
//-return a copy  f

#define TTtoANF(f) (xform(f,ffsize))

#define ANFtoTT(f) (xform(f,ffsize))

void xform(boole f, int n);
//-Transformation polynomiale sur place de la Booleenne f (TrueTable To ANF - ANF To TrueTable)

int weight( int x );

int weightBoole(boole f);

int valuation(boole f);

int degree(boole f);
//-return the degree of the Boolean f


void pTT( FILE*dst, boole f);
void xprint( FILE*dst, boole f);
void panf( FILE*dst, boole f );
void panfvalue( FILE*dst, int v, boole f);
//-prints the anf of f
boole strtoboole( char *bfr );
boole anotherstrtoboole( char *bfr );
boole loadBoole( FILE * src );
boole loadBooleStab(FILE *src, uint64_t  * sz);

void projboole( int i, int j, boole f);
//-kill the terms ouside [i,j]  in f


int * booleChi( boole f );

void Fourier(int *f, unsigned int n );
int isnearbent( boole f );
int linearity( boole f );
int isbent( boole f );

int64_t  norme( boole f );
double   alpha( boole f );

uint64_t aglCardinality( int  m );
uint64_t aglIndex( int  m , uint64_t index );
uint64_t glCardinality( int  m );

int anfdimen( char* str );


void pwalsh(boole f);

void spectrum(boole f);

void addboole( boole g, boole f );
#endif

